﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;

namespace AsyncProcessTable {
	class Program {
		static readonly char[] Separators = { ' ', '\t' };

		static async Task ProcessFile(TextReader input, TextWriter output) {
			var readLineTask = input.ReadLineAsync();
			Task writeLineTask = null;
			string line;
			while ((line = await readLineTask) != null) {
				readLineTask = input.ReadLineAsync();

				string[] words = line.Split(Separators, StringSplitOptions.RemoveEmptyEntries);

				if (writeLineTask != null) {
					await writeLineTask;
				}
				writeLineTask = output.WriteLineAsync(words[0]);
			}
		}

		static void Main(string[] args) {
			using (var sr = new StreamReader(new FileStream("Zelenina.txt", FileMode.Open, FileAccess.Read, FileShare.Read, 16, true))) {
				Console.WriteLine("Reader's stream: IsAsync == {0}", (sr.BaseStream as FileStream).IsAsync);
				using (var sw = new StreamWriter(new FileStream("Vystup.txt", FileMode.Create, FileAccess.Write, FileShare.Read, 16, true))) {
					Console.WriteLine("Writer's stream: IsAsync == {0}", (sw.BaseStream as FileStream).IsAsync);

					ProcessFile(sr, sw).Wait();
				}
			}
		}
	}
}
